#
#   THIS FILE IS UNDER RCS - DO NOT MODIFY UNLESS YOU HAVE
#   CHECKED IT OUT USING THE COMMAND CHECKOUT.
#
#    $Id: makefile.sol 4857 2012-06-19 18:01:15Z ilya $
#
#	Revision history:
#	$Log$
#	Revision 1.3  2010/04/28 21:04:49  stefan
#	removed CC variable since it's set elsewhere and this does compile with Forte cc as well as gcc. Also removed -Wall option, oh well.
#
#	Revision 1.2  2010/03/10 17:30:09  paulf
#	cleaned up makefile.sol for Solaris
#	
#	Revision 1.1  2010/03/10 17:14:58  paulf
#	first check in of ew2mseed to EW proper
#	
#	Revision 1.25  2009/12/21 17:31:28  ilya
#	Fixed a problem which widened gaps in the beginning of day files
#	
#	Revision 1.24  2008/12/30 02:25:27  ilya
#	Modified build process
#	
#	Revision 1.23  2007/09/17 17:31:33  ilya
#	Tested SNCL fixes on Solaris
#	
#	Revision 1.22  2007/07/19 17:46:20  hal
#	Added optional items for "standalone" compilation
#	
#	Revision 1.21  2007/04/12 19:21:04  hal
#	Added ew7.0+ support (-dSUPPORT_SCNL) and linux port (-D_LINUX)
#	
#	-Hal
#	
#	Revision 1.20  2006/09/20 21:48:31  ilya
#	Apperantly fixed the lepseconds bug
#	
#	Revision 1.19  2006/09/20 21:14:52  ilya
#	Apperantly fixed the lepseconds bug
#	
#	Revision 1.18  2006/09/20 21:12:13  ilya
#	Apperantly fixed the lepseconds bug
#	
#	Revision 1.17  2006/07/17 17:26:02  ilya
#	7/17/06
#	
#	Revision 1.16  2005/03/23 03:24:25  ilya
#	Fixed alighnment of data in BUD volumes
#	
#	Revision 1.15  2003/07/24 17:04:19  ilya
#	Integerated new program wsSniffer
#	
#	Revision 1.14  2003/05/16 01:04:18  ilya
#	Added StartLatency
#	
#	Revision 1.13  2003/03/12 19:09:34  ilya
#	Patched condition generated by buggy waverserver
#	
#	Revision 1.12  2003/03/06 22:31:31  ilya
#	ew ws_clientII.c bug fixed
#	
#	Revision 1.11  2003/01/08 23:40:56  ilya
#	Added printf for datatypes
#	
#	Revision 1.10  2002/12/19 00:35:00  ilya
#	Byteswapping in shorts and doubles is fixed
#	
#	Revision 1.9  2002/11/22 16:41:15  ilya
#	Moved file name update down to processing routines from main()
#	
#	Revision 1.8  2002/05/13 16:54:04  ilya
#	More changes for not writing into the wrong file
#	
#	Revision 1.7  2002/05/03 02:35:09  ilya
#	BUG fix: MSEED records -> wrong files
#	
#	Revision 1.6  2002/04/11 20:07:13  ilya
#	Add disabling of catchup mechanism
#	
#	Revision 1.5  2002/04/04 19:26:28  ilya
#	Fixed a bug in processWsGetTraceBin()
#	
#	Revision 1.4  2002/04/02 14:42:01  ilya
#	Version 02-Apr-2002: catchup algorithm
#	
#	Revision 1.3  2002/03/25 20:47:48  ilya
#	Fixed segFaults
#	
#	Revision 1.2  2002/02/21 21:17:19  ilya
#	Bug fixed: use SCN->num instead of SCN->avail in init functions
#	
#	Revision 1.1.1.1  2002/01/24 18:32:05  ilya
#	Exporting only ew2mseed!
#	
#	Revision 1.1.1.1  2001/11/20 21:47:00  ilya
#	First CVS commit
#	
# Revision 1.4  2001/03/15  17:38:29  comserv
# Added NEWS, README, COPYING, CHANGES are replaces by ChangeLog
#
# Revision 1.3  2001/02/23  22:02:13  comserv
# a file isti_ws_client.o  is added to a list of makefile tagets
#
# Revision 1.2  2001/02/23  21:36:14  comserv
# service
#
# Revision 1.1  2000/11/17  06:50:14  comserv
# Initial revision
#

CFLAGS =  $(GLOBALFLAGS) -g  -DDEBUG  -D_SOLARIS -DSUPPORT_SCNL

####
# Uncomment and configure the following 3 lines to compile against an existing EW distro
####
B = $(EW_HOME)/$(EW_VERSION)/bin
L = $(EW_HOME)/$(EW_VERSION)/lib
I = -I $(EW_HOME)/$(EW_VERSION)/include

QLIB = ../../libsrc/qlib2/libqlib2nl.a
QINCLUDE = -I ../../libsrc/qlib2

COMMON_CFLAGS = $(GLOBALFLAGS)  -g $(QINCLUDE)
SNCL_CFLAG = -DSUPPORT_SCNL

ALL = ew2mseed ew2mseed_nl


OBJ = ew2mseed.o \
      ew2mseed_config.o \
      ew2mseed_log.o \
      ew2mseed_files.o \
      ew2mseed_swap.o \
      ew2mseed_utils.o \
      ws_requests.o \
      isti_ws_client.o \
      $(L)/ws_clientII.o

OBJ_NL = $(L)/ws_clientII_no_location.o \
        isti_ws_client_nl.o \
        ws_requests_nl.o \
        ew2mseed_utils_nl.o \
        ew2mseed_swap_nl.o \
        ew2mseed_nl.o \
        ew2mseed_config_nl.o \
        ew2mseed_log_nl.o \
        ew2mseed_files_nl.o

EW_LIBS = \
        $L/logit.o \
        $L/kom.o \
        $L/sema_ew.o \
        $L/threads_ew.o \
        $L/time_ew.o \
        $L/sleep_ew.o \
        $L/socket_ew.o \
        $L/chron3.o \
        $L/swap.o \
        $L/socket_ew_common.o

SRCS = wsSniffer.c
OBJS = $(SRCS:%.c=%.o)
all:	$(ALL)

ew2mseed:  $(OBJ); \
          $(CC) $(QINCLUDE) $(CFLAGS) -o $(B)/ew2mseed $(OBJ) $(EW_LIBS)  $(I) $(QLIB) -lsocket -lnsl -lposix4  -lm

ew2mseed_nl:$(OBJ_NL); \
          $(CC) $(QINCLUDE) $(COMMON_CFLAGS)  -o $(B)/ew2mseed_nl $(OBJ_NL) $(EW_LIBS) $(I) $(QLIB)   -lsocket -lnsl -lposix4  -lm

#wsSniffer:  $(OBJS); \
#           $(CC) $(QINCLUDE) $(CFLAGS) -o $(B)/wsSniffer  $(OBJS) $(EW_LIBS) -lc -lsocket -lnsl -lposix4  -lm 
	
qlib: 
	(echo "making qlib2: -NO_LEAPSECONDS!"; \
	cd ./qlib2; \
	make; pwd)
 
ewlib:	
	(echo "making earthworm_lib"; \
	cd ./earthworm_lib; \
	make -f makefile.sol; pwd)

.c.o:
	$(CC) $(QINCLUDE) -c $(CFLAGS) $(I) $<

ew2mseed_nl.o:  ew2mseed.c 
	$(CC) -c  -o ew2mseed_nl.o ew2mseed.c $(COMMON_CFLAGS)

ew2mseed_config_nl.o:  ew2mseed_config.c 
	$(CC) -c  -o ew2mseed_config_nl.o ew2mseed_config.c $(COMMON_CFLAGS)

ew2mseed_log_nl.o:  ew2mseed_log.c 
	$(CC) -c  -o ew2mseed_log_nl.o ew2mseed_log.c $(COMMON_CFLAGS)

ew2mseed_files_nl.o:  ew2mseed_files.c 
	$(CC) -c  -o ew2mseed_files_nl.o ew2mseed_files.c $(COMMON_CFLAGS)

ew2mseed_swap_nl.o:  ew2mseed_swap.c 
	$(CC) -c  -o ew2mseed_swap_nl.o ew2mseed_swap.c $(COMMON_CFLAGS)

ew2mseed_utils_nl.o:  ew2mseed_utils.c 
	$(CC) -c  -o ew2mseed_utils_nl.o ew2mseed_utils.c $(COMMON_CFLAGS)

ws_requests_nl.o:  ws_requests.c 
	$(CC) -c  -o ws_requests_nl.o ws_requests.c $(COMMON_CFLAGS)

isti_ws_client_nl.o:  isti_ws_client.c 
	$(CC) -c  -o isti_ws_client_nl.o isti_ws_client.c $(COMMON_CFLAGS)


# Clean-up rules
clean:
	 rm -f a.out core *.o *.obj *% *~ 

clean_bin:
	rm -f $B/ew2mseed $B/ew2mseed_nl

