
CFLAGS = -D_REENTRANT $(GLOBALFLAGS)

B = $(EW_HOME)/$(EW_VERSION)/bin
L = $(EW_HOME)/$(EW_VERSION)/lib

LIBS=-lnsl -lsocket -mt -lposix4 -lthread -lc $(LINK_LIBS)


BINARIES = export.o $L/mem_circ_queue.o $L/chron3.o $L/kom.o \
	$L/getsysname_ew.o $L/getutil.o $L/logit_mt.o $L/transport.o \
	$L/sleep_ew.o $L/socket_ew.o $L/socket_ew_common.o \
	$L/time_ew.o $L/threads_ew.o $L/sema_ew.o $L/swap.o

BINARIESACK = export_ack.o $L/mem_circ_queue.o $L/chron3.o $L/kom.o \
	$L/getsysname_ew.o $L/getutil.o $L/logit_mt.o $L/transport.o \
	$L/sleep_ew.o $L/socket_ew.o $L/socket_ew_common.o \
	$L/time_ew.o $L/threads_ew.o $L/sema_ew.o $L/swap.o

BINARIESPRI = export_scn_pri.o $L/priority_queue.o $L/chron3.o $L/kom.o \
	$L/getsysname_ew.o $L/getutil.o $L/logit_mt.o $L/transport.o \
	$L/sleep_ew.o $L/socket_ew.o $L/socket_ew_common.o \
	$L/time_ew.o $L/threads_ew.o $L/sema_ew.o $L/swap.o

BINARIESACTV = export_actv.o $L/mem_circ_queue.o $L/chron3.o $L/kom.o \
	$L/getsysname_ew.o $L/getutil.o $L/logit_mt.o $L/transport.o \
	$L/sleep_ew.o $L/socket_ew.o $L/socket_ew_common.o \
	$L/time_ew.o $L/threads_ew.o $L/sema_ew.o $L/swap.o


all:
	make -f makefile.sol export_generic
	make -f makefile.sol export_scnl
	make -f makefile.sol export_scnl_pri
	make -f makefile.sol export_gen_actv
	make -f makefile.sol export_scnl_actv
	make -f makefile.sol export_ack
	make -f makefile.sol export_scnl_ack


export_generic: $(BINARIES) genericfilter.o
	cc -o $B/export_generic $(BINARIES) genericfilter.o $(LIBS)

export_scnl: $(BINARIES) scnfilter.o $L/rdpickcoda.o
	cc -o $B/export_scnl $(BINARIES) scnfilter.o $L/rdpickcoda.o $(LIBS)

export_scnl_pri: $(BINARIESPRI) scnfilter.o $L/rdpickcoda.o
	cc -o $B/export_scnl_pri $(BINARIESPRI) scnfilter.o $L/rdpickcoda.o $(LIBS)

export_gen_actv: $(BINARIESACTV) genericfilter.o
	cc -o $B/export_gen_actv $(BINARIESACTV) genericfilter.o $(LIBS)

export_scnl_actv: $(BINARIESACTV) scnfilter.o $L/rdpickcoda.o
	cc -o $B/export_scnl_actv $(BINARIESACTV) scnfilter.o $L/rdpickcoda.o $(LIBS)

export_ack: $(BINARIESACK) genericfilter.o
	cc -o $B/export_ack $(BINARIESACK) genericfilter.o $(LIBS)

export_scnl_ack: $(BINARIESACK) scnfilter.o $L/rdpickcoda.o
	cc -o $B/export_scnl_ack $(BINARIESACK) scnfilter.o $L/rdpickcoda.o $(LIBS)



lint:
	lint export.c export_ack.c export_actv.c export_scn_pri.c genericfilter.c scnfilter.c  $(GLOBALFLAGS)


# Clean-up rules
clean:
	rm -f a.out core *.o *.obj *% *~

clean_bin:
	rm -f $B/export_generic* $B/export_scnl* $B/export_*actv* $B/export_*ack*
